import os,sys,cStringIO,itertools,imp
#from .. import format,util
from core import format,util

__package_path = ''
__supports = []
def regist_plugin(plugins):
    global __supports
    __supports = list(plugins)

def get_support_archive():
    archive_types = {}
    for name in __supports:
        archive_type = max(name.split('.'))
        mod = sys.modules[name]
        archive_types[name] = getattr(mod,'ALIAS',['.'+archive_type])
    return archive_types

def __get_match_archiver_name(extension):
    archiver_name = None
    for key,support_extns in get_support_archive().iteritems():
        if extension in support_extns:
            archiver_name = itertools.ifilter(lambda x:x.endswith(key),
                                              __supports).next()
            break
    return archiver_name

def get_archiver(storage):
    filepath = storage.selected_path
    root,extension = os.path.splitext(filepath)
    if root.endswith('.tar'):
        extension = '.tar' + extension
    archiver_name = __get_match_archiver_name(extension)

    archiver = None
    if archiver_name:
        mod = sys.modules[archiver_name]
        archiver = mod.ArchiveFile(storage)
    else:
        support_images = format.get_support_image_extensions()
        if extension in support_images:
            archiver = UnCompressedArchiveFile(storage)

    return archiver

class AbstractArchiveFile(object):
    __support_images = []
    entries = None

    def __init__(self,archive_file):
        self.archive_file = archive_file

    def namelist(self):
        if not self.entries:
            self._cache_entries(
                self.archive_file.namelist()
                )

        return self.entries

    def _cache_entries(self,entries):
        generator = itertools.ifilter(self.filter_filename,entries)
        self.entries = sorted(generator)
        
    def read(self,name):
        return self.archive_file.read(name)

    def close(self):
        self.archive_file.close()

    def filter_filename(self,filename):
        if not self.__support_images:
            self.__support_images = format.get_support_image_extensions()
        ext = os.path.splitext(filename)[1]
        return ext in self.__support_images

class UnCompressedArchiveFile(AbstractArchiveFile):
    def __init__(self,storage):
        self.__storage = storage

    def read(self,filename):
        buf = self.__storage.get_file_data(filename)
        return buf

    def namelist(self):
        generator = itertools.ifilter(self.filter_filename,
                                      self.__storage.list_file())
        return sorted(generator)
    
    def close(self):pass
