import ConfigParser,os
from . import util

class __ApplicationConfig:
    script_dir = None
    __section = 'DEFAULT'
    __defaults = {
        'background_color':'#000000',
        'slideshow_paging_interval':3000,
        'skimming_through_interval':250,
        'scrolled_skimming_activate_time':250,
        'keypressed_skimming_activate_time':100,
        'key_repeat_rate':50,
        'page_cache_size':40,
        'manual_zoom_rate':0.01,
        'magnifier_zoom_rate':1.5,
        'magnifier_size':100,
        'image_fit_mode':0,
        'image_scale_mode':1,
        'left_mouse_button':1,
        'right_mouse_button':3,
        'go_back_mouse_button':8,
        'go_forword_mouse_button':9,
        'is_bfbutton_use_as_skimming':True,
        'is_dualscreen_activate':False,
        'is_right_to_left':True,
        'need_to_hide_cursor_at_fullscreen':True,
        'need_to_hide_toolbar_at_fullscreen':True,
        'need_to_switch_singleview_once':True,
        'need_to_open_last_archive':False,
        'need_to_expand_small_image':False,
        'is_fixed_home_directory':False,
        'fixed_home_directory':'~/',
        'last_opened_directory':'~/',
        'is_window_state_defined':False,
        'window_size':(0,0),
        'window_position':(0,0)
        }

    def __init__(self):
        self.__config_path = os.path.expanduser('~/.gerwalk')
        self.__load_config()

    def __load_config(self):

        parser = ConfigParser.SafeConfigParser(self.__defaults)
        self.__parser = parser

        if os.path.exists(self.__config_path):
            parser.read(self.__config_path)
            self.__load_items(parser.items( self.__section ))
        else:
            self.__load_items(self.__defaults.iteritems())

    def __load_items(self,config_items):
        for option,val in config_items:

            casted_obj = None
            if isinstance(val,str):
                casted_obj = util.cast_str_safety(val)
            else:
                casted_obj = val

            setattr(self, option, casted_obj)

    def __sync_parser_values(self):
        for key in self.__defaults.keys():
            self.__parser.set(self.__section,
                              key,
                              str( getattr(self,key) ) )

    def get_config_keys(self):
        return self.__defaults.keys()

    def save(self):
        f = open(self.__config_path,'w')
        self.__sync_parser_values()
        self.__parser.write(f)
        f.close()

App = __ApplicationConfig()
