import os,os.path,cStringIO,urllib,urlparse
from .. import util

__package_path = ''
def import_plugins(path,plugins):
    global __package_path
    __package_path = path
    util.import_modules(path,plugins)

def treat_file_uri(file_uri):
    filepath = urllib.url2pathname(file_uri)
    filepath = urlparse.urlparse(filepath)[2]
    return filepath

def get_support_storage(file_uri):
    return MountedStorage(file_uri)

class MountedStorage(object):
    def __init__(self,file_uri):
        self.__selected_path = treat_file_uri(file_uri)

    @property
    def selected_path(self):
        return self.__selected_path

    @property
    def selected_file_name(self):
        return os.path.split(self.selected_path)[1]

    @property
    def cwd_name(self):
        return os.path.split(self.cwd_path)[1]

    @property
    def cwd_path(self):
        return os.path.dirname(self.__selected_path)

    def list_file(self,path=None):
        if not path:
            path = self.cwd_path

        return sorted(
            filter(lambda x: not self.isdir(x),os.listdir(path))
            )
    
    def isdir(self,path):
        return os.path.isdir(path)

    def get_file_object(self,path):
        return open( os.path.join(self.cwd_path,  path)
                     ,'rb')
    
    def get_file_data(self,path):
        f = self.get_file_object(path)
        buf = f.read()
        f.close()
        return buf
