import functools,time,imp,os,itertools
def load_plugins(base_dir,mod):
    plugin_ext = '.py'
    mod_dir = os.path.join(base_dir,mod.__path__[0])
    for fdn in itertools.ifilter(lambda entry: not entry.startswith('__') and 
                                 entry.endswith( plugin_ext ),
                                 os.listdir(mod_dir)):
        module_name = fdn.replace( plugin_ext ,'' )
        f,n,d = imp.find_module(module_name,[mod_dir])
        plugin_name = mod.__name__ + '.' + module_name
        imp.load_module(plugin_name,
                        f,n,d)
        yield plugin_name

def is_module_installed(module):
    is_installed = False
    for path in os.environ['PATH'].split(os.pathsep):
        if os.path.exists(os.path.join(path,module)):
            is_installed = True
            break
    return is_installed
    
def cast(typeobj,val):
    casted_obj = None
    if isinstance(val,typeobj):
        casted_obj = val
    elif type == int and isinstance(val,float):
        casted_obj = float_to_int(val)
    else:
        casted_obj = typeobj(val)

    return casted_obj

def cast_str_safety(val):
    casted_obj = None

    if val.isdigit():
        casted_obj = int(val)
    elif isfloat(val):
        casted_obj = float(val)
    elif isboolean(val):
        casted_obj = val == 'True'
    elif istupple(val):
        casted_obj = eval(val)
    else:
        casted_obj = val

    return casted_obj

def isboolean(val):
    is_boolean_obj = False
    if val == 'True' or val == 'False':
        is_boolean_obj = True
    return is_boolean_obj

def istupple(val):
    return val.find(',') > 0

def isfloat(val):
    is_float_obj = False
    splitted_val =  val.split('.')
    if len(splitted_val) == 2:
        is_float_obj = ( splitted_val[0].isdigit() and 
                         splitted_val[1].isdigit() )
    return is_float_obj

def is_greater_list(a,b):
    is_great = True
    if len(a) == len(b):
        for i in range(len(a)):
            if a[i] < b[i]:
                is_great = False
                break

    return is_great

def float_to_int(float_val):
    return int(abs(float_val))

def slice_time(func):
    #switching process time for threads
    #sometimes,threads are locked or stoped by GIL
    @functools.wraps(func)
    def wrapper(*args,**kw):
        time.sleep( 0.001 )
        return func(*args,**kw)
    return wrapper
