#-*- coding: utf-8 -*-
import sys,cStringIO,thread,time,Queue,threading
import os,math,datetime,functools,imp
from core import archive,format,storage,config
from core import ImageDrawer,ArchiveViewer,ImageObjectFactory,ImageConverter
from core import AbstractImageFrame,AbstractImageObject
from core.util import *

BG_COLOR = '#000000'
PAGE_CACHE_SIZE = 40
SLIDESHOW_INTERVAL = 3000
def import_plugins():
    for mod in [archive]:
#        basedir = os.path.join( config.App.script_dir,
#                                          mod.__path__[0] )
        mod.regist_plugin(
            load_plugins(config.App.script_dir,
                         mod)
            )
#        files = os.listdir( basedir )
#        plugins =[]
#        for plugin_file in files:
#            filename = os.path.basename(plugin_file)
            
#            plugin_name,ext = filename.split('.')
#            if ( not plugin_name.startswith('__') and 
#                 ext.endswith('py') or ext.endswith('so') ):

                #plugins.append(plugin_name)
#                plugins.append(plugin_name)
        
#        mod.import_plugins(mod.__path__[0].replace('/','.'),plugins)
#        mod.import_plugins(basedir,plugins)
try:
    import pygtk
    pygtk.require('2.0')
    import gtk,gobject
    import gtk.glade
except:
    print 'Import Error:pygtk,gtk,gtk.glade'
    print 'if upon modules are not installed,please install!'
    sys.exit(1)

class GtkImageHelper:
    conv = ImageConverter()
    def convert_to_pilobject(self,pixbuf):
        pixels = pixbuf.get_pixels()
        size = pixbuf.get_width(),pixbuf.get_height()
        stride = pixbuf.get_rowstride()
        return self.conv.pixels_to_pilobject(size,pixels,stride)
    
    def sharpen(self,pixbuf):
        pilobj = self.convert_to_pilobject(pixbuf)
        pilobj = self.conv.sharpen_image(pilobj)
        sharpen_buf = self.pilobject_to_pixbuf( pilobj,
                                                pixbuf.get_rowstride(),
                                                has_alpha=pixbuf.get_has_alpha())
        del pilobj
        return sharpen_buf

    def pilobject_to_pixbuf(self,pilobj,stride,color=gtk.gdk.COLORSPACE_RGB,
                            has_alpha=False,sample=8):
        width,height = pilobj.size
        img_data = pilobj.tostring()
        pixbuf = gtk.gdk.pixbuf_new_from_data(img_data,color,
                                              has_alpha,sample,
                                              width,height,width*(3 + 1* has_alpha))
        return pixbuf

class MessageDialog(object):
    def __destroy(self,widget,response=None):
        widget.destroy()

    def __connect_handler(self,widget):
        for signal in 'close','response':
            widget.connect(signal,self.__destroy)

    def show(self,text,label=None):
        dialog = gtk.MessageDialog(buttons=gtk.BUTTONS_OK,message_format=label)
        dialog.format_secondary_text(text)
        self.__connect_handler(dialog)
        dialog.show()

class ConfigDialogHelper(object):
    __radio_widgets ={'is_fixed_home_directory':('IsFixedHomeDir',
                                                 'IsLastOpenedDir'),
                      'image_fit_mode':('IsFitAuto',
                                        'IsFitManually',
                                        'IsFitToHeight',
                                        'IsFitToWidth'),
                      'image_scale_mode':('IsScaleFastest',
                                          'IsScaleFaster',
                                          'IsScaleNormal',
                                          'IsScaleSlowest')}

    def __init__(self,widget_tree):
        self.wTree = widget_tree

    def update_config(self):
        def update_config_value(config_key,widget_id):
            value = None
            if config_key in self.__radio_widgets:
                widgets = self.__radio_widgets[config_key]
                for i in range(len(widgets)):
                    if self.wTree.get_widget( widgets[i] ).get_active():
                        value = i
                        break
            else:
                widget = self.wTree.get_widget( widget_id)
                if widget:
                    value = widget.get_value()
            
            if value:
                setattr(config.App,
                        config_key,
                        cast( type( getattr(config.App,config_key)  ),value)
                        )

        self.__iterate_config_keys(update_config_value)

    def init_dialog(self):
        self.__sync_dialog_info()
        self.wTree.get_widget('AppConfigDialog').show()

    def __sync_dialog_info(self):
        def update_widget_value(config_key,widget_id):
            if config_key in self.__radio_widgets:
                self.__set_radio_widget_value(config_key)
            else:
                widget = self.wTree.get_widget( widget_id)
                self.__add_adapter_method(widget)

                if widget:
                    widget.set_value(
                        getattr(config.App,config_key)
                        )
        
        self.__iterate_config_keys(update_widget_value)

    def __iterate_config_keys(self,func):
        for config_key in config.App.get_config_keys():
            widget_id = ''.join( text.title() for text in config_key.split('_') )
            func(config_key,widget_id)

    def __set_radio_widget_value(self,config_key):
        value = getattr(config.App,config_key)
        widget_id = self.__radio_widgets[config_key][value]
        widget = self.wTree.get_widget( widget_id )
        widget.set_active(True)

    def __add_adapter_method(self,widget):
        if isinstance(widget,gtk.FileChooserButton):
            setattr(widget,'set_value',
                    lambda x: widget.set_current_folder( os.path.expanduser(x) )
                    )
            setattr(widget,'get_value',widget.get_uri)
        elif isinstance(widget,gtk.ColorButton):
            setattr(widget,'set_value',
                    lambda x: widget.set_color( gtk.gdk.color_parse(x) )
                    )
            setattr(widget,'get_value',lambda:widget.get_color().to_string())
        elif isinstance(widget,gtk.CheckButton):
            setattr(widget,'get_value',widget.get_active)
            setattr(widget,'set_value',lambda x:widget.set_active(x))

class FileChooserDialogHelper(object):
    def __init__(self,chooser):
        self.chooser = chooser

    def __install_chooser_filter(self,img_pattern,archive_pattern):
        chooser = self.chooser
        for old_filter in chooser.list_filters():
            chooser.remove_filter(old_filter)
    
        new_filters =[]
        for pattern_list,label_text in( (img_pattern.values() + archive_pattern.values(),
                                     'all support format'),
                                    (img_pattern.values(),'all support image'),
                                    (archive_pattern.values(),'all support archive') ):
            pattern = []
            for exts in pattern_list:
                for item in exts:
                    pattern.append(item)
            chooser.add_filter( self.__create_filter(pattern,label_text) )
            
        for pattern in  img_pattern,archive_pattern:
            for filter in self.__create_filter_from_ext(pattern):
                chooser.add_filter(filter)

    def init_chooser(self,extensions,all_patrn_text):
        self.__install_chooser_filter(extensions,all_patrn_text)
        chooser = self.chooser
        chooser.unselect_all()
        self.__resize_dialog()

        cur_dir = ''
        if config.App.is_fixed_home_directory:
            cur_dir = config.App.home_directory
        else:
            cur_dir = config.App.last_opened_directory
        cur_dir = os.path.expanduser( cur_dir )
        chooser.set_current_folder( cur_dir )

        chooser.show()

    def __resize_dialog(self):
        self.chooser.set_size_request(gtk.gdk.screen_width() / 2,
                                      gtk.gdk.screen_height() /2)

    def __create_filter_from_ext(self,extensions):
        filters = []

        for name in sorted(extensions.keys()):
            pattern = extensions[name]
            filters.append( self.__create_filter( pattern ,name) )

        return filters

    def __create_filter(self,pattern,name):
        ffilter = gtk.FileFilter()
        ffilter.set_name(name)
        
        for ext in pattern:
            ffilter.add_pattern('*'+ext)

        return ffilter

class Cursor(object):

    def set(self,cursor_obj):
        #update all of window to affect cursor-image
        for window in gtk.gdk.window_get_toplevels():
            window.set_cursor(cursor_obj)

    def set_type(self,cursor_type):
        self.set(gtk.gdk.Cursor(cursor_type))

    def set_targeted(self): 
        self.set_type(gtk.gdk.TARGET)

    def set_default(self):
        self.set(None)

    def set_image(self,pixbuf,hotspot):
        x,y = hotspot
        cursor_obj = gtk.gdk.Cursor(gtk.gdk.display_get_default(),
                                    pixbuf,
                                    x,
                                    y)
        self.set(cursor_obj)
        
    def hide(self):
        pixmap = gtk.gdk.Pixmap(None, 1, 1, 1)
        color = gtk.gdk.Color()
        self.set(
            gtk.gdk.Cursor(pixmap, pixmap, color, color, 0, 0)
            )
        
class Magnifier(Cursor):
    __manual_zoom_rate = config.App.manual_zoom_rate
    __magnifier_size = config.App.magnifier_size
    __magnifier_zoom_rate = config.App.magnifier_zoom_rate
    
    def __init__(self,drawer):
        self.drawer = drawer

    def create_cursor(self,widget,x,y):
        cursor_point = (x,y)
        img_rect = self.__calc_image_rect(widget)
        img_w,img_h = img_rect[2:]
        mag_point = [cursor_point[x] - img_rect[x]  for x in range(2)]

        mag_img = self.__create_mag_image(widget.get_name(),
                                          img_w,
                                          img_h,
                                          mag_point)
        self.__set_mag_cursor(mag_img)
    
    def __calc_image_rect(self,widget):
        halign,valign = widget.get_alignment()
        rect = widget.get_allocation()
        frame_name = widget.get_name()
        img_w,img_h = self.drawer.frame_content_info[frame_name][1]
        img_rect = ( (rect.width - img_w) * halign,
                    (rect.height - img_h) * valign,
                    img_w,
                    img_h)

        return img_rect

    def __set_mag_cursor(self,img):
        if img:
            hotspot = self.__magnifier_size / 2 ,self.__magnifier_size / 2
            super(self.__class__,self).set_image(img,hotspot)
            del img
        else:
            super(self.__class__,self).set_targeted()

    def __create_mag_image(self,frame_name,img_w,img_h,mag_point):
        mag_size = self.__magnifier_size
        zoom_rate = self.__magnifier_zoom_rate
        pz_mag_size = mag_size / zoom_rate

        mag_img = None
        if ( is_greater_list([p - pz_mag_size /2 for p in  mag_point],(0,0)) and
             is_greater_list((img_w,img_h),[p + pz_mag_size /2 for p in mag_point])
             ):

            pixbuf = self.drawer.get_magnifier_base(frame_name)
            point = [ float_to_int( p * zoom_rate) - mag_size /2 for p in mag_point  ]
            subpix_img = pixbuf.subpixbuf( point[0],
                                           point[1],
                                           mag_size ,mag_size)

            if subpix_img:
                mag_img = subpix_img.add_alpha(False,'W','T','F')
                del subpix_img

        return mag_img

class GImageFrame(AbstractImageFrame):
    def __init__(self,frame_widget):
        self.widget = frame_widget
    
    @property
    def name(self):
        return self.widget.get_name()

    def hide(self):
        self.widget.get_parent().hide()

    def show(self):
        self.widget.get_parent().show()

    def draw_image(self,img):
        self.widget.set_from_pixbuf(img)
    
    def set_alignment(self,xalign,yalign):
        self.widget.set_alignment(xalign,yalign)

class GImageObject(AbstractImageObject):
    __size = None
    __build_wait_time = 0.0005
    pixbuf = None
    def __init__(self,data):
        loader = gtk.gdk.PixbufLoader()
        loader.connect('size_prepared',self.__size_prepared)
        loader.connect('area_prepared',self.__area_prepared)
        self.__write_data(loader,data)

    def __del__(self):
        if self.pixbuf:
            del self.pixbuf

    def __write_data(self,loader,data):
        if not loader.write(data):
            raise 'io error or someting...'
        loader.close()

    def __size_prepared(self,loader,width,height):
        self.__size = width,height

    def __area_prepared(self,loader):
        self.pixbuf = loader.get_pixbuf()

    @property
    def size(self):
        if self.__size:
            return self.__size
        while not self.__size:
            time.sleep(self.__build_wait_time)
        return self.__size

    @property
    def content(self):
        while not self.pixbuf:
            time.sleep(self.__build_wait_time)
        return self.pixbuf

    def resize(self,size,rotate_angle=None,need_flip=None,mode=gtk.gdk.INTERP_TILES):
        width,height = size
        resized_img = self.content

        if rotate_angle:
            resized_img = resized_img.rotate_simple(rotate_angle)

        if need_flip:
            horizontal,vertical = need_flip
            if horizontal:
                resized_img = resized_img.flip(True)

            if vertical:
                resized_img = resized_img.flip(False)
        
        resized_img = resized_img.scale_simple(width,height,mode)
        return resized_img
    
class ComicBrowser(object):
    __is_sleeping = False
    __is_magnifier_activate = False
    __cur_size = 0,0
    __box_margin = None
    viewer = None
    drawer = None
    __prev_pressed_key = None
    __omitted_func = None
    __is_key_repeat = False
    __slideshow_thread = None
    __is_slideshow_activate = False
    __is_skimming_through_activate = False
    __is_fullscreened = False
    __prev_mouse_scroll_time = 0
    __prev_key_press_time = 0
    cursor = Cursor()
    __error =''
    def __init__(self):
        self.wTree = gtk.glade.XML('viewer.glade')
        self.wTree.signal_autoconnect(self)
        gobject.timeout_add(10, self.__delay_init)

    def __delay_init(self):
        self.__attach_widgets(
            ("MainWindow",'PageJumpDialog','ArchiveFileChooserDialog',
             "ImageContainer",'MainMenuBar','PageNumSpinButton',
             "PageImageRight","PageImageLeft")
        )

        self.imgbox_adjusts = (self.ImageContainer.get_hadjustment(),
                               self.ImageContainer.get_vadjustment())

        self.drawer = ImageDrawer( GImageFrame(self.PageImageRight),
                                   GImageFrame(self.PageImageLeft))

        self.img_factory = ImageObjectFactory(GImageObject)

        self.__set_bg_color()
        self.__redefine_mainwindow_state()

        return False

    def __attach_widgets(self,widget_names):
        for widget_name in widget_names:
            setattr(self,widget_name,self.wTree.get_widget(widget_name))

    def __redefine_mainwindow_state(self):
        window_size = 0,0
        window_pos = None
        screen_size = ( gtk.gdk.screen_width(),
                        gtk.gdk.screen_height() )

        if config.App.is_window_state_defined:
            window_size = config.App.window_size
            window_pos = config.App.window_position

        if window_size == (0,0) or \
                is_greater_list(window_size,screen_size):
            window_size = [val / 2 for val in screen_size]

        self.MainWindow.set_size_request(window_size[0],
                                         window_size[1])
        
        if window_pos and is_greater_list(screen_size,window_pos):
            x,y = window_pos
            self.MainWindow.move(x,y)
        
        self.MainWindow.show()

    def __viewr_related_menu_activate(self,is_active):
        self.wTree.get_widget('miView').set_sensitive(is_active)
        self.wTree.get_widget('miMove').set_sensitive(is_active)

    def __wake_up_from_slideshow(self):
        if self.__is_slideshow_activate:
            self.__is_skimming_through_activate = False
            self.__is_slideshow_activate = False
            gobject.source_remove(self.__timer_source)
            self.__print_archive_info()

    def __set_bg_color(self):
        color = gtk.gdk.color_parse(config.App.background_color)
        self.ImageContainer.modify_bg(gtk.STATE_NORMAL,
                              color)


    def __print_archive_info(self,label_texts=[]):
        label = ' '.join(label_texts)
        archive_info_text =  self.viewer.info.__str__() + ' ' + label
        self.MainWindow.set_title(archive_info_text)
        
    def __start_slideshow(self,interval,move_func,mode_label=None):
        @slice_time
        def __activate_slideshow():
            move_func()

            if self.__is_slideshow_activate:
                self.__print_archive_info([mode_label])
            else:
                self.__print_archive_info()

            return self.__is_slideshow_activate

        self.__is_slideshow_activate = True

        if not mode_label:
            mode_label = '-slideshow mode-'

        self.__print_archive_info([mode_label])
        self.__timer_source = gobject.timeout_add(interval,
                                                  __activate_slideshow)

    def __start_skimming_through(self,func):
        self.__is_skimming_through_activate = True
        self.__start_slideshow(config.App.skimming_through_interval,
                               func,
                               '-skimming mode-')

    def __delegate_move_func(self,func):
        if self.__is_skimming_through_activate:return

        #for preventing to leak magnifier-cursor,set target-cursor at once
        if self.__is_magnifier_activate:
            self.cursor.set_targeted()
        if self.__is_key_repeat:
            self.__start_skimming_through(func)
        else:
            func()
            self.MainWindow.set_title(self.viewer.info.__str__())

    def __activate_miFitManually(self):
        mi = self.wTree.get_widget('miFitManually')
        if not mi.get_active():
            mi.set_active(True)
        if self.drawer.get_fit_mode() != self.drawer.FIT_MANUALLY:
            self.drawer.set_fit_mode(self.drawer.FIT_MANUALLY)
        else:
            self.drawer.redraw()

    def __set_menubar_visibility(self,is_visible):
        if is_visible:
            self.MainMenuBar.set_size_request(-1,-1)
        else:
            self.MainMenuBar.set_size_request(0,0)

    @slice_time
    def on_miSlideshow_activate(self,widget):
        self.__start_slideshow(config.App.slideshow_paging_interval,
                               self.viewer.move_next_page)

    def on_CommonDialog_delete_event(self,widget,event):
        return widget.hide_on_delete()

    def on_PageJumpDialog_response(self,widget,response):
        if response == gtk.RESPONSE_OK:
            self.viewer.move_page_to( self.PageNumSpinButton.get_value() )
        widget.hide()

    @slice_time
    def on_miMoveToInputedPage_activate(self,widget):
        if not self.viewer:return
        spin = self.PageNumSpinButton ; viewer = self.viewer
        minimum ,maximum = spin.get_range()
        page_sum = viewer.get_page_sum() - 1
        if maximum != page_sum:
            self.wTree.get_widget('PageSumLabel').set_text(str(page_sum))
            spin.set_range(0,page_sum)
            spin.set_value(viewer.get_page_number())

        self.PageJumpDialog.show()

    @slice_time
    def on_miMoveToNext_activate(self,widget):
        self.__delegate_move_func(self.viewer.move_next_page)

    @slice_time
    def on_miMoveToPrev_activate(self,widget):
        self.__delegate_move_func(self.viewer.move_prev_page)

    @slice_time
    def on_miMoveToFirst_activate(self,widget):
        self.viewer.move_first_page()

    @slice_time
    def on_miMoveToLast_activate(self,widget):
        self.viewer.move_last_page()

    @slice_time
    def on_miFullscreen_toggled(self,widget):
        need_to_hide_cursor = config.App.need_to_hide_cursor_at_fullscreen
        need_to_hide_toolbar = config.App.need_to_hide_toolbar_at_fullscreen
        self.__is_fullscreened = widget.get_active()
        if self.__is_fullscreened:
            if need_to_hide_cursor:
                self.cursor.hide()

            if need_to_hide_toolbar:
                self.__set_menubar_visibility(False)

            self.MainWindow.fullscreen()
        else:
            if need_to_hide_cursor:
                self.cursor.set_default()

            if need_to_hide_toolbar:
                self.__set_menubar_visibility(True)

            self.MainWindow.unfullscreen()

    @slice_time
    def on_miRightToLeft_toggled(self,widget):
        self.drawer.set_right_to_left_mode( widget.get_active() )

    @slice_time
    def on_miDualview_toggled(self,widget):
        is_active = widget.get_active()
        self.drawer.set_dualscreen_mode(is_active)

    @slice_time
    def on_miFitAuto_toggled(self,widget):
        if widget.get_active():
            self.drawer.set_fit_mode(self.drawer.FIT_AUTO)

    @slice_time
    def on_miFitToWidth_toggled(self,widget):
        if widget.get_active():
            self.drawer.set_fit_mode(self.drawer.FIT_TO_WIDTH)

    @slice_time
    def on_miFitToHeight_toggled(self,widget):
        if widget.get_active():
            self.drawer.set_fit_mode(self.drawer.FIT_TO_HEIGHT)

    def __zoom_image(self,zooming_func):
        new_rates = []
        for current_rate in self.drawer.get_manual_zoom_rate():
            new_rate = zooming_func( current_rate )
            new_rates.append( new_rate )
        self.drawer.set_manual_zoom_rate( new_rates)

    def on_miMagnifierShow_activate(self,widget):
        self.__is_magnifier_activate =  not self.__is_magnifier_activate
        self.drawer.need_to_create_mag_cache(self.__is_magnifier_activate)
        if self.__is_magnifier_activate:
            self.cursor.set_targeted()
        else:
            if self.__is_fullscreened and config.App.need_to_hide_cursor_at_fullscreen:
                self.cursor.hide()
            else:
                self.cursor.set_default()

    @slice_time
    def on_miZoomOrigin_activate(self,widget):
        self.__zoom_img_obj(lambda x:1.0)
        self.__activate_miFitManually()

    @slice_time
    def on_miZoomIn_activate(self,widget):
        self.__zoom_img_obj(lambda cur_rate: cur_rate + config.App.manual_zoom_rate )
        self.__activate_miFitManually()
        
    @slice_time
    def on_miZoomOut_activate(self,widget):
        def zoom_out(current_rate):
            new_rate = current_rate - config.App.manual_zoom_rate
            if new_rate < 0.0: new_rate = current_rate
            return new_rate
        self.__zoom_img_obj(zoom_out)
        self.__activate_miFitManually()

    def on_miFlipHorizontal_activate(self,widget):
        self.drawer.flip_image(True)

    def on_miFlipVertical_activate(self,widget):
        self.drawer.flip_image(False)

    def on_miRotateClockwise_activate(self,widget):
        self.drawer.rotate_image(gtk.gdk.PIXBUF_ROTATE_CLOCKWISE)

    def on_miRotateAntiClockwise_activate(self,widget):
        self.drawer.rotate_image(gtk.gdk.PIXBUF_ROTATE_COUNTERCLOCKWISE)

    def on_miRotate180_activate(self,widget):
        self.drawer.rotate_image(180)

    def on_miRotateOrign_activate(self,widget):
        self.drawer.need_to_keep_rotation(False)

    def on_miKeepRotation_toggled(self,widget):
        self.drawer.need_to_keep_rotation(widget.get_active())

    def on_miMenubarVisible_toggled(self,widget):
        self.__set_menubar_visibility(widget.get_active())

    def on_miArchiveFileOpen_activate(self,widget):
        helper = FileChooserDialogHelper(self.ArchiveFileChooserDialog)
        helper.init_chooser(
            format.get_support_image(),
            archive.get_support_archive()
            )

    def on_ArchiveFileChooserDialog_response(self,widget,response):
        if response == gtk.RESPONSE_OK:
            file_uri = widget.get_uri()
            storage_obj = storage.get_support_storage(file_uri)
            config.App.last_opened_directory = storage_obj.cwd_path

            if self.viewer:
                self.viewer.terminate()
                del self.viewer
            self.viewer = ArchiveViewer(self.drawer,self.img_factory)
            self.viewer.run(storage_obj)
            self.__viewr_related_menu_activate(True)
            self.__print_archive_info()
        widget.hide()

    def on_miEditAppConfig_activate(self,widget):
        ConfigDialogHelper(self.wTree).init_dialog()

    def on_miAppInfo_activate(self,widget):
        self.wTree.get_widget('AboutAppDialog').show()

    def on_AppConfigDialog_response(self,widget,response):
        if response == gtk.RESPONSE_OK:
            ConfigDialogHelper(self.wTree).update_config()
            self.__set_bg_color()
        widget.hide()

    def on_AboutAppDialog_response(self,widget,response):
        widget.hide()

    def __set_mag_cursor_image(self,widget,event):
        Magnifier(self.drawer).create_cursor(widget,
                                             event.x,
                                             event.y)

    def on_PageImageEventBoxLeft_motion_notify_event(self,widget,event):
        if self.viewer and self.__is_magnifier_activate:
                self.__set_mag_cursor_image(self.PageImageLeft,event)

    def on_PageImageEventBoxRight_motion_notify_event(self,widget,event):
        if self.viewer and self.__is_magnifier_activate:
                self.__set_mag_cursor_image(self.PageImageRight,event)
                
    @slice_time
    def on_PageImageEventBoxLeft_button_press_event(self,widget,event):
        if self.viewer:

            #click-based paging support only LEFT-BUTTON
            if event.button != config.App.left_mouse_button:return
            if self.drawer.get_right_to_left_mode():
                self.__delegate_move_func(self.viewer.move_next_page)
            else:
                self.__delegate_move_func(self.viewer.move_prev_page)

    @slice_time
    def on_PageImageEventBoxRight_button_press_event(self,widget,event):
        if self.viewer:

            #click-based paging support only LEFT-BUTTON
            if event.button != config.App.left_mouse_button:return
            if not self.drawer.get_dualscreen_mode():
                self.__delegate_move_func(self.viewer.move_next_page)
            else:
                if self.drawer.get_right_to_left_mode():
                    self.__delegate_move_func(self.viewer.move_prev_page)
                else:
                    self.__delegate_move_func(self.viewer.move_next_page)

    @slice_time
    def on_MainWindow_size_allocate(self,widget,allocation):
        wm_size = self.MainWindow.get_size()

        if self.__cur_size !=  wm_size:
            self.__cur_size = wm_size
            hadjust,vadjust = self.imgbox_adjusts
            self.__box_margin = (wm_size[0] - self.ImageContainer.allocation.width,
                                 self.MainMenuBar.allocation.height)

            #syncronize drawer's container-size with available drawing-area
            box_w,box_h = [wm_size[0] - self.__box_margin[0],
                           wm_size[1] - self.__box_margin[1]]
            self.drawer.set_container_size(box_w,
                                           box_h)
            if self.viewer:
                self.drawer.redraw()

    @slice_time
    def on_MainWindow_window_state_event(self,widget,event):
        max_state = gtk.gdk.WINDOW_STATE_MAXIMIZED
        is_max_before = (event.changed_mask & max_state) != 0
        is_max_now =  (event.new_window_state & max_state) != 0
        if is_max_before or is_max_now:
            self.on_MainWindow_size_allocate(widget,None)

    def on_MainWindow_button_press_event(self,widget,event):
        self.__is_key_repeat = False
        self.__wake_up_from_slideshow()
        button = event.button
        move_func = None
        if button == config.App.go_back_mouse_button:
            move_func = self.viewer.move_prev_page
        elif button == config.App.go_forword_mouse_button:
            move_func = self.viewer.move_next_page
            
        if move_func:
            if config.App.is_bfbutton_use_as_skimming:
                self.__start_skimming_through(move_func)
            else:
                self.__delegate_move_func(move_func)
        
        return False

    def on_MainWindow_scroll_event(self,widget,event):
        if self.viewer:
            if event.time - self.__prev_mouse_scroll_time \
                    < config.App.scrolled_skimming_activate_time:
                self.__is_key_repeat = True
            else:
                self.__is_key_repeat = False
                self.__wake_up_from_slideshow()
            self.__prev_mouse_scroll_time = event.time

            scroll_dir = event.direction
            if scroll_dir == gtk.gdk.SCROLL_UP:
                self.__delegate_move_func(self.viewer.move_prev_page)
            elif scroll_dir == gtk.gdk.SCROLL_DOWN:
                self.__delegate_move_func(self.viewer.move_next_page)
            
    def on_MainWindow_key_release_event(self,widget,event):
        if self.viewer:
            if event.time - self.__prev_key_press_time \
                    < config.App.key_repeat_rate:return
            if event.keyval == gtk.keysyms.s:
                return
            if self.__is_slideshow_activate:
                self.__wake_up_from_slideshow()
            self.__prev_pressed_key = None

    def on_MainWindow_key_press_event(self,widget,event):
        #if key-press-event repeat until emitting release-event,
        #the move-func works as slideshow,and omit the func hereafter

        if self.viewer:
            if event.time - self.__prev_key_press_time \
                    < config.App.keypressed_skimming_activate_time:
                self.__is_key_repeat = True
            else:
                self.__is_key_repeat = False

            self.__prev_key_press_time = event.time

            if event.keyval == gtk.keysyms.s:
                return

            if self.__is_skimming_through_activate:
                return 
            
            #compare with previous key and currrent key for key-repeat-check
#            key_info = event.keyval,event.state
#            if self.__prev_pressed_key != key_info:
#                self.__prev_pressed_key = key_info
#            if event.time - self.__prev_key_press_time \
#                    < 500:#config.App.scrolled_skimming_activate_time:
#                self.__is_key_repeat = True
#            else:
#                self.__is_key_repeat = False
#                if event.keyval == gtk.keysyms.s:
#                    return
                #self.__wake_up_from_slideshow()            

            #here from compare key conditions
            keyval =  event.keyval
            is_ctrl = not (event.state & gtk.gdk.CONTROL_MASK) == 0
            hadjust,vadjust = self.imgbox_adjusts
            move_prev_page = self.viewer.move_prev_page
            move_next_page = self.viewer.move_next_page

            if keyval == gtk.keysyms.Right:
                if is_ctrl:
                    self.__on_Scrollbar_changed(hadjust,
                                                True)
                else:
                    if self.drawer.get_right_to_left_mode():
                        self.__delegate_move_func(move_prev_page)
                    else:
                        self.__delegate_move_func(move_next_page)
            elif keyval == gtk.keysyms.Left:
                if is_ctrl:
                    self.__on_Scrollbar_changed(hadjust,
                                                False)
                else:
                    if self.drawer.get_right_to_left_mode():
                        self.__delegate_move_func(move_next_page)
                    else:
                        self.__delegate_move_func(move_prev_page)
            elif keyval == gtk.keysyms.Up:
                if is_ctrl:
                    self.__on_Scrollbar_changed(vadjust,
                                                False)
            elif keyval == gtk.keysyms.Down:
                if is_ctrl:
                    self.__on_Scrollbar_changed(vadjust,
                                                True)
    @slice_time
    def __on_Scrollbar_changed(self,adjust,is_increased):
        if not adjust.upper == 0:
            increment = adjust.step_increment
            newval = 0
            if is_increased:
                newval = adjust.value + increment
                max = adjust.upper - adjust.page_size
                if newval > max:
                    newval = max
            else:
                newval = adjust.value - increment
                if newval < 0:
                    newval = 0
            adjust.value = newval

    def on_miAppQuit_activate(self,widget):
        self.MainWindow.destroy()

    def on_MainWindow_destroy(self,widget):
        if self.viewer:
            self.viewer.terminate()

        config.App.window_size = widget.get_size()
        config.App.window_position = widget.get_position()

        gtk.main_quit()

    def main(self):
        gtk.main()

def main():
    script_path = os.path.realpath(__file__)
    script_dir = os.path.split(script_path)[0]
    config.App.script_dir = script_dir
    
    import_plugins()
    try:
        cb = ComicBrowser()
        cb.main()

#        config.App.save()
    except:
        print sys.exc_info()

if __name__ == '__main__':
    main()
