# -*- coding: utf-8 -*-
import subprocess,itertools
import ctypes

class SevenZipFile(object):
    __read_command = []
    entries = None
    def __init__(self,file):
        self.file = file

    def close(self):
        pass

    def namelist(self):
        if not self.entries:
            command = ['7z','l','-slt',self.file]
            path_line_prefix = 'Path = '
            stdout = self.__call_proc(self.__create_proc_obj(command))
            generator = itertools.ifilter(lambda x:x.startswith(path_line_prefix),
                                          stdout.splitlines())
            generator = itertools.imap(lambda x: x.lstrip(path_line_prefix),
                                       generator)
            self.entries = generator
        return self.entries

    def read(self,name):
        if not self.__read_command:
            self.__read_command = ['7z','e','-so',self.file]
        archiver_proc = self.__create_proc_obj(self.__read_command + [name])
        return self.__call_proc(
            self.__create_proc_obj(['cat'],
                                   archiver_proc.stdout)
            )

    def __create_proc_obj(self,command,stdin_pipe=None):
        return subprocess.Popen(command,
                                stdin=stdin_pipe,
                                stdout=subprocess.PIPE)

    def __call_proc(self,proc_obj):
        result =proc_obj.communicate()[0]
        return result
